/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class ContentSecurityInfo 
	{
        
		// Entity member variables for database table epContentSecurity
        
		private Int32 mContentSecurityId;
		private Int32 mMetaDataId;
		private string mContentAuthorizedViewer;
        
		// Calculated Expression member variables for database table epContentSecurity
        
        
		// Entity properties for database table epContentSecurity
        
		public Int32 ContentSecurityId 
		{
			get { return mContentSecurityId; }
			set { mContentSecurityId = value; }
		}
        
        
		public Int32 MetaDataId 
		{
			get { return mMetaDataId; }
			set { mMetaDataId = value; }
		}
        
        
		public string ContentAuthorizedViewer 
		{
			get { return mContentAuthorizedViewer; }
			set { mContentAuthorizedViewer = value; }
		}
        
        
	}
    
	public class ContentSecurityController : BaseController
	{
		public ContentSecurityController() : base() {}
		public ContentSecurityController(ConnectionProvider cp) : base(cp) {}
        
		public Int32 Add(ContentSecurityInfo ContentSecurityInfo) 
		{
			return (Int32) base.GetDataProvider().ContentSecurityAdd(ContentSecurityInfo.MetaDataId, ContentSecurityInfo.ContentAuthorizedViewer);
		}
        
		public void Update(ContentSecurityInfo ContentSecurityInfo) 
		{
			base.GetDataProvider().ContentSecurityUpdate(ContentSecurityInfo.ContentSecurityId, ContentSecurityInfo.MetaDataId, ContentSecurityInfo.ContentAuthorizedViewer);
		}
        
		public void Delete(Int32 contentSecurityId) 
		{
			base.GetDataProvider().ContentSecurityDelete(contentSecurityId);
		}
        
		public ContentSecurityInfo GetItem(Int32 contentSecurityId) 
		{
			using (IDataReader idr = base.GetDataProvider().ContentSecurityGet(contentSecurityId))
			{
				ContentSecurityInfo infoObject = (ContentSecurityInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(ContentSecurityInfo));
				return infoObject;
			} 
		}
        
		// Relation methods for database table epContentSecurity
		public ArrayList GetByMetaData(Int32 metaDataId) 
		{
			using (IDataReader idr = base.GetDataProvider().ContentSecurityByMetaData(metaDataId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(ContentSecurityInfo));
				return infoList;
			} 
		}
	}
}
