/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2007
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;

namespace DNNContentBuilder.UI.WebControls.DataBinding
{
	/// <summary>
	/// Strives to avoid keeping a copy of the data source within custom 
	/// data bound controls.
	/// </summary>
	public abstract class AbstractBindingModel
	{
		#region Constructors
		protected AbstractBindingModel()
		{
		}
		#endregion

		#region Properties
		public abstract string Name
		{
			get;
		}

		public abstract int Count
		{
			get;
		}
		#endregion

		#region Implementation
		
		public abstract void WriteXml(System.IO.TextWriter writer);
		public abstract string[] GetColumns();
		
		#endregion
	}
}
