/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
    
	[Serializable]
	public class DatabaseInfo 
	{
        
		// Entity member variables for database table epDatabase
        
		private Int32 mDatabaseId;
		private string mSysTableQuery;
		private string mSysColumnQuery;
		private string mTitle;
		private string mSysSchema;
        
		// Calculated Expression member variables for database table epDatabase
        
        
		// Entity properties for database table Database
        
		public Int32 DatabaseId 
		{
			get { return mDatabaseId; }
			set { mDatabaseId = value; }
		}
        
		public string Title 
		{
			get { return mTitle; }
			set { mTitle = value; }
		}

		public string SysTableQuery 
		{
			get { return mSysTableQuery; }
			set { mSysTableQuery = value; }
		}

		public string SysColumnQuery 
		{
			get { return mSysColumnQuery; }
			set { mSysColumnQuery = value; }
		}

		public string SysSchema 
		{
			get { return mSysSchema; }
			set { mSysSchema = value; }
		}
	}
    
	public class DatabaseController : BaseController
	{
		public DatabaseController() : base() {}
		public DatabaseController(ConnectionProvider cp) : base(cp) {}

        /* Only in the next version...
		public Int32 Add(DatabaseInfo csInfo) 
		{
			return (Int32) base.GetDataProvider().DatabaseAdd(csInfo.SysTableQuery, csInfo.Title, csInfo.Database);
		}
        
		public void Update(DatabaseInfo DatabaseInfo) 
		{
			base.GetDataProvider().DatabaseUpdate(DatabaseInfo.DatabaseId, DatabaseInfo.SysTableQuery, DatabaseInfo.Title, DatabaseInfo.Database);
		}
        
		public void Delete(Int32 DatabaseId) 
		{
			base.GetDataProvider().DatabaseDelete(DatabaseId);
		}
        */

		public DatabaseInfo GetItem(Int32 DatabaseId) 
		{
			using (IDataReader idr = base.GetDataProvider().DatabaseGet(DatabaseId))
			{
				DatabaseInfo infoObject = (DatabaseInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(DatabaseInfo));
				return infoObject;
			} 
		}

		// Select query methods for database table epDatabase
		public ArrayList GetAllDatabases() 
		{
			using (IDataReader idr = base.GetDataProvider().DatabaseGetAllDatabases())
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(DatabaseInfo));
				return infoList;
			} 
		}
	}
}
