/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class FormDefinitionInfo 
	{
        
		// Entity member variables for database table epFormDefinition
        
		private Int32 mFormDefinitionId;
		private string mTitle;
		private string mCSS;
        
		// Calculated Expression member variables for database table epFormDefinition
        
        
		// Entity properties for database table epFormDefinition
        
		public Int32 FormDefinitionId 
		{
			get { return mFormDefinitionId; }
			set { mFormDefinitionId = value; }
		}

		public string Title 
		{
			get { return mTitle; }
			set { mTitle = value; }
		}

		public string CSS 
		{
			get { return mCSS; }
			set { mCSS = value; }
		}
	}
    
	public class FormDefinitionController : BaseController
	{
		public FormDefinitionController() : base() {}
		public FormDefinitionController(ConnectionProvider cp) : base(cp) {}

		public Int32 Add(FormDefinitionInfo FormDefinitionInfo) 
		{
			return (Int32)base.GetDataProvider().FormDefinitionAdd(FormDefinitionInfo.Title, FormDefinitionInfo.CSS);
		}
        
		public void Update(FormDefinitionInfo FormDefinitionInfo) 
		{
			base.GetDataProvider().FormDefinitionUpdate(FormDefinitionInfo.FormDefinitionId, FormDefinitionInfo.Title, FormDefinitionInfo.CSS);
		}
        
		public void Delete(Int32 formDefinitionId) 
		{
			base.GetDataProvider().FormDefinitionDelete(formDefinitionId);
		}
        
		public FormDefinitionInfo GetItem(Int32 formDefinitionId) 
		{
			using (IDataReader idr = base.GetDataProvider().FormDefinitionGet(formDefinitionId))
			{
				FormDefinitionInfo infoObject = (FormDefinitionInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(FormDefinitionInfo));
				return infoObject;
			} 
		}
        
		// Select query methods for database table epFormDefinition
		public FormDefinitionInfo GetFormByTitle(string formTitle) 
		{
			using (IDataReader idr = base.GetDataProvider().FormDefinitionGetByTitle(formTitle.ToUpper()))
			{
				FormDefinitionInfo infoObject = (FormDefinitionInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(FormDefinitionInfo));
				return infoObject;
			} 
		}
        
		public ArrayList GetAllFormDefinition() 
		{
			using (IDataReader idr = base.GetDataProvider().FormDefinitionGetAllFormDefinition())
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(FormDefinitionInfo));
				return infoList;
			} 
		}
        
		public ArrayList GetFormDefinitionDataConnections() 
		{
			using (IDataReader idr = base.GetDataProvider().FormDefinitionGetFormDefinitionDataConnections())
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(FormDefinitionInfo));
				return infoList;
			} 
		}
        
		public ArrayList GetFormDefinitionFieldDefinition() 
		{
			using (IDataReader idr = base.GetDataProvider().FormDefinitionGetFormDefinitionFieldDefinition())
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(FormDefinitionInfo));
				return infoList;
			} 
		}
	}
}
