/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;
using System.ComponentModel;

namespace DNNContentBuilder 
{
	[Serializable]
	public class MetaDataEventInfo 
	{
		// Entity member variables for database table cbMetaDataEvent
        
		private Int32 mEventId;
		private Int32 mMetaDataId;
		private Int32 mUserId;
		private string mDescription;
		private string mDetails;
		private string mEventType;
		private string mUsername;
		private DateTime mEventDate;

        
		// Entity properties for database table cbMetaDataEvent
        
		public Int32 EventId 
		{
			get { return mEventId; }
			set { mEventId = value; }
		}

		public Int32 UserId 
		{
			get { return mUserId; }
			set { mUserId = value; }
		}

		public Int32 MetaDataId 
		{
			get { return mMetaDataId; }
			set { mMetaDataId = value; }
		}

		public string Description
		{
			get { return mDescription; }
			set { mDescription = value; }
		}

		public string Details
		{
			get { return mDetails; }
			set { mDetails = value; }
		}

        
		public DateTime EventDate 
		{
			get { return mEventDate; }
			set { mEventDate = value; }
		}

		public TypeOfEvent EventType 
		{
			get
			{
				return (TypeOfEvent)TypeDescriptor.GetConverter(typeof(TypeOfEvent)).ConvertFromString(mEventType);
			}
			set
			{
				mEventType = TypeDescriptor.GetConverter(typeof(TypeOfEvent)).ConvertToString(value);
			}
		}

		public string InternalType
		{
			get { return mEventType; }
			set { mEventType = value; }
		}
		
		public string Username
		{
			get { return mUsername; }
			set { mUsername = value; }
		}
	}
    
	public class MetaDataEventController : BaseController
	{
		public MetaDataEventController() : base() {}
		public MetaDataEventController(ConnectionProvider cp) : base(cp) {}
        
		public Int32 Add(MetaDataEventInfo MetaDataEventInfo) 
		{
			return (Int32) base.GetDataProvider().MetaDataEventAdd(MetaDataEventInfo.MetaDataId, MetaDataEventInfo.InternalType, MetaDataEventInfo.Description, MetaDataEventInfo.Details, MetaDataEventInfo.UserId, MetaDataEventInfo.EventDate);
		}

		
		public MetaDataEventInfo GetItem(Int32 eventId) 
		{
			using (IDataReader idr = base.GetDataProvider().MetaDataEventGet(eventId))
			{
				MetaDataEventInfo infoObject = (MetaDataEventInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(MetaDataEventInfo));
				return infoObject;
			} 
		}
		
		public ArrayList GetEventsByMetaData(Int32 metaDataId)
		{
			using (IDataReader idr = base.GetDataProvider().MetaDataEventGetByMetaDataId(metaDataId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(MetaDataEventInfo));
				return infoList;
			} 
		}
		
	}
}
