/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Web.UI.WebControls;
using System.Xml;

namespace DNNContentBuilder.UserControls.FieldControls
{
    /// <summary>
	///		Summary description for TextBox.
	/// </summary>
	public class CommonDef : System.Web.UI.UserControl, IFormletDef
	{
		public const string resource = "~/DesktopModules/DNNContentBuilder/App_LocalResources/CommonDef";
		
		protected TextBox  txtFriendlyName;
		protected TextBox  txtCssClass;
		protected CheckBox chkSearch;
		protected CheckBox chkRequired;
		protected CheckBox chkVisible;
		protected CheckBox chkIsTitle;
		protected TextBox  txtToolTip;

		private void Page_Load(object sender, EventArgs e)
		{
			// Put user code to initialize the page here
			
			if (txtFriendlyName.Text.Length == 0 && Page.FindControl((string)Session["lastButton"]) != null) 
			{
				System.Web.UI.Control lastButton = Page.FindControl((string)Session["lastButton"]);

				XmlDocument tempXml = new XmlDocument();

				XmlNode tempNode;
				
				tempXml.LoadXml(((ImageButton)lastButton).CommandArgument);

				tempNode = tempXml.SelectSingleNode("//SourceField");

				this.txtFriendlyName.Text = tempNode.InnerText;
			}
		}

		public void GetXml (string xml) 
		{
			XmlDocument tempXml = new XmlDocument();

			XmlNode tempNode;
				
			tempXml.LoadXml(xml);

			tempNode = tempXml.SelectSingleNode("//FriendlyName");
			tempNode.InnerText = this.txtFriendlyName.Text;

			tempNode = tempXml.SelectSingleNode("//CssClass");
			tempNode.InnerText = this.txtCssClass.Text;

			tempNode = tempXml.SelectSingleNode("//Tooltip");
			tempNode.InnerText = this.txtToolTip.Text;

			tempNode = tempXml.SelectSingleNode("//Required");
			tempNode.InnerText = this.chkRequired.Checked.ToString();

			tempNode = tempXml.SelectSingleNode("//Search");
			tempNode.InnerText = this.chkSearch.Checked.ToString();

			tempNode = tempXml.SelectSingleNode("//Visible");
			tempNode.InnerText = this.chkVisible.Checked.ToString();

			tempNode = tempXml.SelectSingleNode("//UniqueId");
			
			System.Web.UI.Control lastButton = Page.FindControl(tempNode.InnerText);

			((ImageButton)lastButton).CommandArgument = tempXml.OuterXml;
		}

		public void SetXml (string extProperties) 
		{
			XmlDocument xml = new XmlDocument();

			XmlNode tempNode;
				
			xml.LoadXml(extProperties);

			tempNode = xml.SelectSingleNode("//FriendlyName");
			
			txtFriendlyName.Text = tempNode.InnerText;

			if (txtFriendlyName.Text == "") 
			{
				tempNode = xml.SelectSingleNode("//SourceField");
				txtFriendlyName.Text = tempNode.InnerText;
			}

			tempNode = xml.SelectSingleNode("//Tooltip");
			
			txtToolTip.Text = tempNode.InnerText;


			tempNode = xml.SelectSingleNode("//CssClass");
			
			this.txtCssClass.Text = tempNode.InnerText;


			tempNode = xml.SelectSingleNode("//Search");
			
			if (tempNode.InnerText.ToLower() == "true") 
			{
				this.chkSearch.Checked = true;
			} else {
				this.chkSearch.Checked = false;
			}
 
			tempNode = xml.SelectSingleNode("//Required");
			
			if (tempNode.InnerText.ToLower() == "true") 
			{
				this.chkRequired.Checked = true;
			} 
			else 
			{
				this.chkRequired.Checked = false;
			}

			tempNode = xml.SelectSingleNode("//Visible");
			
			if (tempNode.InnerText.ToLower() == "false") 
			{
				this.chkVisible.Checked = false;
			} 
			else 
			{
				this.chkVisible.Checked = true;
			}

			tempNode = xml.SelectSingleNode("//IsTitle");
			
			if (tempNode.InnerText.ToLower() == "true") 
			{
				this.chkIsTitle.Checked = true;
			} 
			else 
			{
				this.chkIsTitle.Checked = false;
			}
		}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}//class
}//namespace
