/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using System.Web.UI.WebControls;
using System.Xml;

namespace DNNContentBuilder.UserControls.FieldControls
{
    /// <summary>
	///		Summary description for TextBox.
	/// </summary>
	public class DropDownDef : System.Web.UI.UserControl, IFormletDef
	{
		public const string resource = "~/DesktopModules/DNNContentBuilder/App_LocalResources/DropDownDef";

		private readonly XmlDocument xmlDoc = new XmlDocument();
		private   XmlNode tempNode;

		protected ArrayList fieldList = new ArrayList();
		protected DataConnectionInfo dcInfoTemp;
		protected DropDownList ddDataConnection;
		protected DropDownList ddOptionText;
		protected DropDownList ddOptionValue;
		protected TextBox txtWhere;
		protected TextBox txtOrderBy;
		protected Button btTest;
		protected Literal ltTestResult;

		private void Page_Load(object sender, EventArgs e)
		{
			// Put user code to initialize the page here

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddDataConnection.SelectedIndexChanged += new System.EventHandler(this.ddDataConnection_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		public void SetXml (string extProperties) 
		{
			XmlDocument xml = new XmlDocument();

			xml.LoadXml(extProperties);

			tempNode = xml.SelectSingleNode("//DropDown");

			if (tempNode == null) 
			{
				XmlDocument tempXml = new XmlDocument();

				tempXml.LoadXml(extProperties);

				tempNode = tempXml.SelectSingleNode("//ExtendedProperties");

				XmlDocument cbXml = new XmlDocument();

				cbXml.Load(System.Web.HttpContext.Current.Server.MapPath("~\\DesktopModules\\DNNContentBuilder\\UserControls\\FieldControls\\XML\\DropDownDef.xml"));

				tempNode.InnerXml = cbXml.InnerXml;

				xmlDoc.LoadXml(tempXml.OuterXml);
			} 
			else 
			{
				xmlDoc.LoadXml(extProperties);
			}

			//Fill Option text and option value

			FillddDataConnection(xmlDoc.InnerXml);

			tempNode = xmlDoc.SelectSingleNode("//DropDown/DataConnectionId");
			
			for (int loop = 0;loop < ddDataConnection.Items.Count;loop++) {
				if (ddDataConnection.Items[loop].Value == tempNode.InnerText) {
					ddDataConnection.SelectedIndex = loop;
					break;
				}
			}
			
			tempNode = xmlDoc.SelectSingleNode("//OptionText");
			
			for (int loop = 0;loop < ddOptionText.Items.Count;loop++) {
				if (ddOptionText.Items[loop].Value  == tempNode.InnerText) {
					ddOptionText.SelectedIndex = loop;
					break;
				}
			}

			tempNode = xmlDoc.SelectSingleNode("//OptionValue");
			
			for (int loop = 0;loop < ddOptionValue.Items.Count;loop++) {
				if (ddOptionValue.Items[loop].Text == tempNode.InnerText) {
					ddOptionValue.SelectedIndex = loop;
					break;
				}
			}

			tempNode = xmlDoc.SelectSingleNode("//Where");
			txtWhere.Text = tempNode.InnerText;
				
			tempNode = xmlDoc.SelectSingleNode("//OrderBy");
			txtOrderBy.Text = tempNode.InnerText;

			System.Web.UI.Control lastButton = Page.FindControl((string)Session["lastButton"]);

			((ImageButton)lastButton).CommandArgument = xmlDoc.OuterXml;
		}

		public void FillddDataConnection(string xml) 
		{
			//TODO: that method needs revision
			
			xmlDoc.LoadXml(xml);

			DataConnectionController dcController = new DataConnectionController();

			this.ddDataConnection.DataSource = (ArrayList)dcController.GetAllDataConnections();
			this.ddDataConnection.DataTextField = "TableName";
			this.ddDataConnection.DataValueField = "DataConnectionId";
			this.ddDataConnection.DataBind();

			tempNode = xmlDoc.SelectSingleNode("//DropDown/DataConnectionId");
			
			if (tempNode.InnerText == "") 
			{
				if (this.ddDataConnection.Items.Count > 0) 
				{
					ddDataConnection.SelectedIndex = 0;
					dcInfoTemp = (DataConnectionInfo)dcController.GetItem(Int32.Parse(this.ddDataConnection.SelectedValue));
					tempNode.InnerText = this.ddDataConnection.SelectedValue;
				} 
			} else {
				dcInfoTemp = dcController.GetItem(Int32.Parse(tempNode.InnerText));
				this.ddDataConnection.SelectedValue = tempNode.InnerText;
			}

			ConnectionStringController csController = new ConnectionStringController();
			DatabaseController dbController = new DatabaseController();

			ConnectionStringInfo csInfo = (ConnectionStringInfo)csController.GetItem(dcInfoTemp.ConnectionStringId);

			DatabaseInfo dbInfo = (DatabaseInfo)dbController.GetItem(csInfo.DatabaseId);

			OleDbConnection tableSourceConnection = new OleDbConnection(csInfo.ConnectionString);

			OleDbCommand tableSourceCommand = new OleDbCommand(dbInfo.SysColumnQuery.Replace("@table_name", this.ddDataConnection.SelectedItem.Text), tableSourceConnection);

			try 
			{
				tableSourceConnection.Open();

				OleDbDataReader tableSourceReader = tableSourceCommand.ExecuteReader(CommandBehavior.CloseConnection);
				
				while (tableSourceReader.Read()) 
				{
					fieldList.Add(new FieldInfo(tableSourceReader.GetString(0).Remove(0, tableSourceReader.GetString(0).IndexOf(".")+1) + "(" + tableSourceReader.GetString(2) + ")", tableSourceReader.GetString(0), tableSourceReader.GetString(2),0,0, ""));
				}
			}
			catch (Exception error) 
			{
#pragma warning disable 168
				string x = error.Message; //just for debug
#pragma warning restore 168
				return;
			}

			this.ddOptionText.DataSource = fieldList;
			this.ddOptionText.DataTextField = "name";
			this.ddOptionText.DataValueField = "columnProperties";
			this.ddOptionText.DataBind();

			this.ddOptionValue.DataSource = fieldList;
			this.ddOptionValue.DataTextField = "name";
			this.ddOptionValue.DataValueField = "columnProperties";
			this.ddOptionValue.DataBind();
		}

		public void GetXml (string xml) 
		{
			XmlDocument tempXml = new XmlDocument();

			tempXml.LoadXml(xml);

			tempNode = tempXml.SelectSingleNode("//DropDown/DataConnectionId");
			tempNode.InnerText = this.ddDataConnection.SelectedValue;
			
			tempNode = tempXml.SelectSingleNode("//OptionText");
			tempNode.InnerText = this.ddOptionText.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//OptionValue");
			tempNode.InnerText = this.ddOptionValue.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//Where");
			tempNode.InnerText = this.txtWhere.Text;

			tempNode = tempXml.SelectSingleNode("//OrderBy");
			tempNode.InnerText = this.txtOrderBy.Text;
			
			tempNode = tempXml.SelectSingleNode("//UniqueId");
			
			System.Web.UI.Control lastButton = Page.FindControl(tempNode.InnerText);
			
			((ImageButton)lastButton).CommandArgument = tempXml.OuterXml;
		}

		private void ddDataConnection_SelectedIndexChanged(object sender, EventArgs e)
		{
			System.Web.UI.Control lastButton = Page.FindControl((string)Session["lastButton"]);

			xmlDoc.LoadXml(((ImageButton)lastButton).CommandArgument);

			tempNode = xmlDoc.SelectSingleNode("//DropDown/DataConnectionId");
			tempNode.InnerText = ddDataConnection.SelectedValue;

			tempNode = xmlDoc.SelectSingleNode("//OptionText");
			tempNode.InnerText = "";

			tempNode = xmlDoc.SelectSingleNode("//OptionValue");
			tempNode.InnerText = "";
			
			this.FillddDataConnection(xmlDoc.InnerXml);
		}
	}//class
}//namespace
