/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Web.UI.WebControls;

namespace DNNContentBuilder.UserControls
{
    /// <summary>
	///		Summary description for TaskListControl.
	/// </summary>
	public class ScheduleListControl : System.Web.UI.UserControl
	{
		public const string resource = "~/DesktopModules/DNNContentBuilder/App_LocalResources/ScheduleListControl";

		protected UI.WebControls.PagerBuilder PagerBuilder1;
		protected DataList dlScheduleList;
		
		private readonly MetaDataController metaDataController = new MetaDataController();
/*
		private MetaDataInfo metaDataInfo = new MetaDataInfo();
*/
	
		private void Page_Load(object sender, EventArgs e)
		{
			FillScheduleList();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dlScheduleList.ItemCreated += new System.Web.UI.WebControls.DataListItemEventHandler(this.dlScheduleList_ItemCreated);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void FillScheduleList()
		{
			ArrayList scheduleList = metaDataController.GetScheduledContent(ContextUtil.GetPortalId(this), ContextUtil.GetModuleId(this));

			this.PagerBuilder1.Visible = false;
			dlScheduleList.Visible = false;

			if (scheduleList.Count > 0) 
			{
				try 
				{
					dlScheduleList.DataSource = scheduleList;
					dlScheduleList.DataBind();
					this.PagerBuilder1.Visible = true;
					dlScheduleList.Visible = true;
				}
				catch (Exception e)
				{
#pragma warning disable 168
					string err = e.Message;
#pragma warning restore 168
				}
			}
		}

		private void dlScheduleList_ItemCreated(object sender, DataListItemEventArgs e)
		{// This is not fair
			if ((e.Item.ItemType == ListItemType.Item) || (e.Item.ItemType == ListItemType.AlternatingItem))
			{
				///Del Schedule image button
				ImageButton btDelSchedule = (ImageButton) e.Item.FindControl("btDelSchedule");

				btDelSchedule.Click += btDelSchedule_Click;
			}

		}

		private void btDelSchedule_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			ImageButton btDelSchedule = (System.Web.UI.WebControls.ImageButton)sender; 

			metaDataController.DeleteSchedule(Int32.Parse(btDelSchedule.CommandArgument));

			this.FillScheduleList();
		}
	}
}
