/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

namespace DNNContentBuilder.UserControls
{
	public delegate void TemplateDetailsEventHandler(object sender, TemplateDetailsEventArgs e);

	/// <summary>
	/// Provides event arguments for the TemplateDetailsEventHandler 
	/// delegate.
	/// </summary>
	public class TemplateDetailsEventArgs : System.EventArgs
	{
		#region Class Members
		private string eventType;
		#endregion

		#region Constructors
		/// <summary>
		/// Initializes a new instance of the TemplateDetailsEventArgs class.
		/// </summary>
		/// <param name="metaDataId"></param>
		public TemplateDetailsEventArgs(string eventTypeName)
		{
			this.eventType = eventTypeName;
		}
		#endregion

		#region Properties
		/// <summary>
		/// Gets the metadata ID for the row clicked
		/// </summary>
		public string EventType
		{
			get
			{
				return eventType;
			}
		}
		#endregion
	}
}
