/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

namespace DNNContentBuilder
{
	using System;
	using DotNetNuke.Entities.Modules;
	using System.Reflection;

	/// <summary>
	///		Summary description for DNNContentBuilderModule.
	/// </summary>
	public class ContentModelerModule : PortalModuleBase, DotNetNuke.Entities.Modules.IActionable
	{
		public const string resource = "~/DesktopModules/DNNContentBuilder/App_LocalResources/ContentModelerView";

		protected System.Web.UI.WebControls.ImageButton btTemplateWorkbench;
		protected System.Web.UI.WebControls.ImageButton btConnectionString;
		protected System.Web.UI.WebControls.ImageButton btDataConnection;
		protected System.Web.UI.WebControls.ImageButton btFormBuilder;
		protected System.Web.UI.WebControls.ImageButton btWorkflow;

		protected DNNContentBuilder.UserControls.TemplateWorkbenchControl TemplateWorkbenchControl1;
		protected DNNContentBuilder.UserControls.DataConnectionControl DataConnectionControl1;
		protected DNNContentBuilder.UserControls.ConnectionStringControl ConnectionStringControl1;
		protected DNNContentBuilder.UserControls.FormBuilderControl FormBuilderControl1;
		protected DNNContentBuilder.UserControls.WorkflowControl WorkflowControl1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			// Pop-ups cannot access portal settings. The session var below provides access to portalid var
			Session["URPortalID"] = ContextUtil.GetPortalId(this);

		}

		#region Properties
		public DotNetNuke.Entities.Modules.Actions.ModuleActionCollection ModuleActions  
		{
			get 
			{
				DotNetNuke.Entities.Modules.Actions.ModuleActionCollection actions = new DotNetNuke.Entities.Modules.Actions.ModuleActionCollection();

				actions.Add(GetNextActionID(), "Formlet Uploader", "","","", this.EditUrl("Formlet Uploader","","FormletUploaderControl"), "", false, DotNetNuke.Security.SecurityAccessLevel.Admin, true, false);

				return actions;
			}
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btFormBuilder.Click += new System.Web.UI.ImageClickEventHandler(this.btFormBuilder_Click);
			this.btWorkflow.Click += new System.Web.UI.ImageClickEventHandler(this.btWorkflow_Click);
			this.btDataConnection.Click += new System.Web.UI.ImageClickEventHandler(this.btDataConnection_Click);
			this.btConnectionString.Click += new System.Web.UI.ImageClickEventHandler(this.btConnectionString_Click);
			this.btTemplateWorkbench.Click += new System.Web.UI.ImageClickEventHandler(this.btTemplateWorkbench_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btDataConnection_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			HideControls();

			this.DataConnectionControl1.Visible = true;
		}

		private void btConnectionString_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			HideControls();

			this.ConnectionStringControl1.Visible = true;
		}

		private void btTemplateWorkbench_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			HideControls();

			this.TemplateWorkbenchControl1.Visible = true;
		}

		private void HideControls()
		{
			this.TemplateWorkbenchControl1.Visible = false;
			this.WorkflowControl1.Visible = false;
			this.ConnectionStringControl1.Visible = false;
			this.DataConnectionControl1.Visible = false;
			this.FormBuilderControl1.Visible = false;
		}

		private void btFormBuilder_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			HideControls();

			this.FormBuilderControl1.Visible = true;

			Session.Remove("fieldList");
			Session.Remove("dataConnectionsSelectedList");
			Session.Remove("dataConnectionList");
			Session.Remove("myHeader");
			Session.Remove("myControl");
			Session.Remove("myFooter");
			Session.Remove("lastButton");
		}

		private void btWorkflow_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			HideControls();

			this.WorkflowControl1.Visible = true;
		}
	}
}
