/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class FormDataConnectionsInfo 
	{
        
		// Entity member variables for database table epFormDataConnections
        
		private Int32 mFormDefinitionId;
		private Int32 mDataConnectionId;
        
		// Calculated Expression member variables for database table epFormDataConnections
        
        
		// Entity properties for database table epFormDataConnections
        
		public Int32 FormDefinitionId 
		{
			get { return mFormDefinitionId; }
			set { mFormDefinitionId = value; }
		}
        
        
		public Int32 DataConnectionId 
		{
			get { return mDataConnectionId; }
			set { mDataConnectionId = value; }
		}
	}

	public class FormDataConnectionsController : BaseController
	{
		public FormDataConnectionsController() : base() {}
		public FormDataConnectionsController(ConnectionProvider cp) : base(cp) {}
        
		public void Add(FormDataConnectionsInfo FormDataConnectionsInfo) 
		{
			base.GetDataProvider().FormDataConnectionsAdd(FormDataConnectionsInfo.FormDefinitionId, FormDataConnectionsInfo.DataConnectionId);
		}
        
		public void Update(FormDataConnectionsInfo FormDataConnectionsInfo) 
		{
			base.GetDataProvider().FormDataConnectionsUpdate(FormDataConnectionsInfo.FormDefinitionId, FormDataConnectionsInfo.DataConnectionId);
		}
        
		public void Delete(Int32 formDefinitionId, Int32 dataConnectionId) 
		{
			base.GetDataProvider().FormDataConnectionsDelete(formDefinitionId, dataConnectionId);
		}
        
		public void DeleteByFormDefinition(Int32 formDefinitionId) 
		{
			base.GetDataProvider().FormDataConnectionsDeleteByFormDefinition(formDefinitionId);
		}

		public FormDataConnectionsInfo GetItem(Int32 formDefinitionId, Int32 dataConnectionId) 
		{
			using (IDataReader idr = base.GetDataProvider().FormDataConnectionsGet(formDefinitionId, dataConnectionId))
			{
				FormDataConnectionsInfo infoObject = (FormDataConnectionsInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(FormDataConnectionsInfo));
				return infoObject;
			}
		}
        
		// Relation methods for database table epFormDataConnections
		public ArrayList GetByDataConnection(Int32 dataConnectionId) 
		{
			using (IDataReader idr = base.GetDataProvider().FormDataConnectionsByDataConnection(dataConnectionId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(FormDataConnectionsInfo));
				return infoList;
			} 
		}
        
		public ArrayList GetByFormDefinition(Int32 formDefinitionId) 
		{
			using (IDataReader idr = base.GetDataProvider().FormDataConnectionsByFormDefinition(formDefinitionId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(FormDataConnectionsInfo));
				return infoList;
			} 
		}
	}
}
