/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class MetaDataLabelInfo 
	{
		// Entity member variables
        
		private Int32 mMetaDataId;
		private Int32 mLabelId;
        
        
		// Entity properties
        
		public Int32 MetaDataId 
		{
			get { return mMetaDataId; }
			set { mMetaDataId = value; }
		}
        
		public Int32 LabelId 
		{
			get { return mLabelId; }
			set { mLabelId = value; }
		}
	}
    
	public class MetaDataLabelController : BaseController
	{
		public MetaDataLabelController() : base() {}
		public MetaDataLabelController(ConnectionProvider cp) : base(cp) {}

		public Int32 Add(MetaDataLabelInfo MetaDataLabelInfo) 
		{
			return (Int32) base.GetDataProvider().MetaDataLabelAdd(MetaDataLabelInfo.MetaDataId, MetaDataLabelInfo.LabelId);
		}
        
		public void Delete(Int32 metaDataId, Int32 labelId)
		{
			base.GetDataProvider().MetaDataLabelDelete(metaDataId, labelId);
		}
        
		public void DeleteByLabel(Int32 labelId)
		{
			base.GetDataProvider().MetaDataLabelDeleteByLabel(labelId);
		}
	}
}
