/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;
using System.ComponentModel;

namespace DNNContentBuilder 
{
	[Serializable]
	public class MetaDataTaskOwnerInfo 
	{
        
		// Entity member variables for database table epMetaDataTask
        
		private Int32 mMetaDataTaskOwnerId;
		private Int32 mMetaDataTaskId;
		private string mOwnerType;
		private Int32 mOwnerId;
        
		// Calculated Expression member variables for database table epMetaDataTask
        
        
		// Entity properties for database table epMetaDataTask
        
		public Int32 MetaDataTaskId 
		{
			get { return mMetaDataTaskId; }
			set { mMetaDataTaskId = value; }
		}
        
		public Int32 MetaDataTaskOwnerId 
		{
			get { return mMetaDataTaskOwnerId; }
			set { mMetaDataTaskOwnerId = value; }
		}

		public string OwnerType 
		{
			get { return mOwnerType; }
			set { mOwnerType = value; }
		}

		public Int32 OwnerId 
		{
			get { return mOwnerId; }
			set { mOwnerId = value; }
		}
	}
    
	public class MetaDataTaskOwnerController : BaseController
	{
		public MetaDataTaskOwnerController() : base() {}
		public MetaDataTaskOwnerController(ConnectionProvider cp) : base(cp) {}
        
		public Int32 Add(MetaDataTaskOwnerInfo MetaDataTaskOwnerInfo) 
		{
			return (Int32) base.GetDataProvider().MetaDataTaskOwnerAdd(MetaDataTaskOwnerInfo.OwnerId, MetaDataTaskOwnerInfo.OwnerType, MetaDataTaskOwnerInfo.MetaDataTaskId);
		}
        
		public void Update(MetaDataTaskOwnerInfo MetaDataTaskOwnerInfo) 
		{
			base.GetDataProvider().MetaDataTaskOwnerUpdate(MetaDataTaskOwnerInfo.MetaDataTaskOwnerId, MetaDataTaskOwnerInfo.OwnerId, MetaDataTaskOwnerInfo.OwnerType, MetaDataTaskOwnerInfo.MetaDataTaskId);
		}

		public void DeleteAll(Int32 metaDataTaskId) 
		{
			base.GetDataProvider().MetaDataTaskOwnerDeleteAll(metaDataTaskId);
		}

		public void Delete(Int32 metaDataTaskOwnerId) 
		{
			base.GetDataProvider().MetaDataTaskOwnerDelete(metaDataTaskOwnerId);
		}
        
		public MetaDataTaskOwnerInfo GetItem(Int32 metaDataTaskOwnerId) 
		{
			using (IDataReader idr = base.GetDataProvider().MetaDataTaskOwnerGet(metaDataTaskOwnerId))
			{
				MetaDataTaskOwnerInfo infoObject = (MetaDataTaskOwnerInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(MetaDataTaskOwnerInfo));
				return infoObject;
			} 
		}

		public ArrayList GetNextTaskOwners(Int32 taskId)
		{
			using (IDataReader idr = base.GetDataProvider().MetaDataTaskOwnerGetNext(taskId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(TaskOwnerInfo));
				return infoList;
			} 
		}

	
	}
}
