/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;

namespace DNNContentBuilder
{
	/// <summary>
	/// Summary description for ScheduleTask.
	/// </summary>
	public class Publisher : DotNetNuke.Services.Scheduling.SchedulerClient
	{
		public Publisher(DotNetNuke.Services.Scheduling.ScheduleHistoryItem item) : base()
		{
			this.ScheduleHistoryItem = item; //a new comment
		}


		public override void DoWork()
		{
			try 
			{
				//notification that the event is progressing
				this.Progressing();

				CheckSchedule();

				this.ScheduleHistoryItem.Succeeded = true;

				this.ScheduleHistoryItem.AddLogNote("Content Builder schedule updated");
			}

			catch (Exception e) 
			{

				this.ScheduleHistoryItem.Succeeded = false;

				this.ScheduleHistoryItem.AddLogNote("Content Builder schedule failed:" + e.ToString());

				this.Errored(ref e); // notify somebody about this error
			}
		}

		public void CheckSchedule() 
		{
			MetaDataController metaDataController = new MetaDataController();

			DotNetNuke.Entities.Portals.PortalController portalController = new DotNetNuke.Entities.Portals.PortalController();

			ArrayList portals = new ArrayList();

			portals = portalController.GetPortals();

			foreach (DotNetNuke.Entities.Portals.PortalInfo portal in portals) 
			{
				metaDataController.PublishScheduledContent(portal.PortalID);
			}
		}

	}
}

