/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class TaskOwnerInfo 
	{
        
		// Entity member variables for database table epTaskOwner
        
		private Int32 mTaskOwnerId;
		private Int32 mOwnerId;
		private string mOwnerType;
		private Int32 mTaskId;
        
		// Calculated Expression member variables for database table epTaskOwner
        
        
		// Entity properties for database table epTaskOwner
        
		public Int32 TaskOwnerId 
		{
			get { return mTaskOwnerId; }
			set { mTaskOwnerId = value; }
		}
        
        
		public Int32 OwnerId 
		{
			get { return mOwnerId; }
			set { mOwnerId = value; }
		}
        
        
		public string OwnerType 
		{
			get { return mOwnerType; }
			set { mOwnerType = value; }
		}
        
		public Int32 TaskId 
		{
			get { return mTaskId; }
			set { mTaskId = value; }
		}
	}
    
	public class TaskOwnerController : BaseController
	{
		public TaskOwnerController() : base() {}
		public TaskOwnerController(ConnectionProvider cp) : base(cp) {}
        
		public Int32 Add(TaskOwnerInfo TaskOwnerInfo) 
		{
			return (Int32) base.GetDataProvider().TaskOwnerAdd(TaskOwnerInfo.OwnerId, TaskOwnerInfo.OwnerType, TaskOwnerInfo.TaskId);
		}
        
		public void Update(TaskOwnerInfo TaskOwnerInfo) 
		{
			base.GetDataProvider().TaskOwnerUpdate(TaskOwnerInfo.TaskOwnerId, TaskOwnerInfo.OwnerId, TaskOwnerInfo.OwnerType, TaskOwnerInfo.TaskId);
		}
        
		public void Delete(Int32 taskOwnerId) 
		{
			base.GetDataProvider().TaskOwnerDelete(taskOwnerId);
		}
        
		public TaskOwnerInfo GetItem(Int32 taskOwnerId) 
		{
			using (IDataReader idr = base.GetDataProvider().TaskOwnerGet(taskOwnerId))
			{
				TaskOwnerInfo infoObject = (TaskOwnerInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(TaskOwnerInfo));
				return infoObject;
			} 
		}
        
		// Select query methods for database table epTaskOwner
		public ArrayList TaskOwnerGetTaskOwners(Int32 taskId)
		{
			using (IDataReader idr = base.GetDataProvider().TaskOwnerGetTaskOwners(taskId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(TaskOwnerInfo));
				return infoList;
			} 
		}

		public ArrayList GetTasksByOwner(Int32 OwnerId) 
		{
			using (IDataReader idr = base.GetDataProvider().TaskOwnerGetTasksByOwner(OwnerId))
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(TaskOwnerInfo));
				return infoList;
			} 
		}
	}
}
