/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/
using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace DNNContentBuilder
{
	/// <summary>
	/// Summary description for ThumbNail.
	/// </summary>
	public class ThumbNail : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				MakeThumbNail();
			}
			catch (Exception ex)
			{
				string message = ex.Message;
			}
		}

		private void MakeThumbNail() 
		{
			string file = Page.Request.Params["file"];

			if (file == null)
			{
				return;
			}
			
			file = Server.MapPath(file);

			using (Image image = System.Drawing.Image.FromFile(file))
			{
				int width  = Page.Request["width"]  != null ? Int32.Parse(Page.Request["width"])  : 0;
				int height = Page.Request["height"] != null ? Int32.Parse(Page.Request["height"]) : image.Width / width;

				using (Image thumbNail = image.GetThumbnailImage(width, height, null, System.IntPtr.Zero))
				{
					Response.ContentType = file.ToLower().IndexOf("jpg") != -1 ? "image/jpeg" : "image/gif";
					thumbNail.Save(Response.OutputStream, Response.ContentType == "image/jpeg" ? ImageFormat.Jpeg : ImageFormat.Gif);
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
