/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using DNNContentBuilder.UserControls.SearchFieldControls;

namespace DNNContentBuilder.UserControls.FieldControls
{
	using System;
	using System.Xml;
	using DNNContentBuilder.Attributes;

	/// <summary>
	///		Summary description for DropDownControl.
	/// </summary>
	[FormEngineSearchControl(typeof(TextSearchControl))]
	public class FilePickerControl : DNNContentBuilder.UserControls.FieldControls.BaseFieldControl, IFormlet
	{
		private bool isValid = true;

		private XmlDocument xmlDoc = new XmlDocument();
		private XmlNode xmlNode;

		protected System.Web.UI.UserControl myFilePicker;

		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region IFormlet Members

		public bool IsValid
		{
			get
			{
				return this.isValid;
			}
		}

		public string GetValue(string XML)
		{
			isValid = true;
			
			xmlDoc.LoadXml(XML);

			xmlNode = xmlDoc.SelectSingleNode("//SystemType");
			xmlNode.InnerText = "String";

			xmlNode = xmlDoc.SelectSingleNode("//Value");

			xmlNode.InnerText = ((DotNetNuke.UI.UserControls.UrlControl)myFilePicker).Url;
			
			string selectedValue = xmlNode.InnerText;

			xmlNode = xmlDoc.SelectSingleNode("//IsRequired");
			
			if (xmlNode.InnerText.ToLower() == "true") {
				if (selectedValue == "") {
					this.isValid = false;
				}
			}
			
			return xmlDoc.InnerXml;
		}

		public void SetValue(string XML)
		{
			xmlDoc.LoadXml(XML);

			xmlNode = xmlDoc.SelectSingleNode("//Value");

			((DotNetNuke.UI.UserControls.UrlControl)myFilePicker).Url = xmlNode.InnerText;
		}

		public void SetConfig(string XML) 
		{
			xmlDoc.LoadXml(XML);

			xmlNode = xmlDoc.SelectSingleNode("//DestinationFolder");

			DotNetNuke.UI.UserControls.UrlControl filePicker = myFilePicker as DotNetNuke.UI.UserControls.UrlControl;

			filePicker.FileFilter = "";
			filePicker.ShowFiles  = true;
			filePicker.ShowTabs   = false;
			filePicker.ShowUrls   = false;
			filePicker.ShowLog	  = false;
			filePicker.Url		  = xmlNode.InnerText;
			filePicker.UrlType	  = "F";
			
			filePicker.Attributes.Add("CssClass", ContextUtil.GetAttributeValue(xmlDoc, "CssClass",  ""));
		}
		#endregion
	}
}
