/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

namespace DNNContentBuilder.UserControls.FieldControls
{
	using System;
	using System.Collections;
	using System.Data;
	using System.Data.OleDb;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Xml;
	using System.IO;

	/// <summary>
	///		Summary description for TextBox.
	/// </summary>
	public class ListBoxDef : System.Web.UI.UserControl, IFormletDef
	{
		public const string resource = "~/DesktopModules/DNNContentBuilder/App_LocalResources/ListBoxDef";

		private   System.Xml.XmlDocument xmlDoc = new XmlDocument();
		private   XmlNode tempNode;

		protected ArrayList fieldList = new ArrayList();
		protected DNNContentBuilder.DataConnectionInfo dcInfoTemp;
		protected System.Web.UI.WebControls.DropDownList ddDataConnection;
		protected System.Web.UI.WebControls.DropDownList ddOptionText;
		protected System.Web.UI.WebControls.DropDownList ddOptionValue;
		protected System.Web.UI.WebControls.DropDownList ddListSize;
		protected System.Web.UI.WebControls.TextBox txtWhere;
		protected System.Web.UI.WebControls.TextBox txtOrderBy;
		protected System.Web.UI.WebControls.Button btTest;
		protected System.Web.UI.WebControls.Literal ltTestResult;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here



		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddDataConnection.SelectedIndexChanged += new System.EventHandler(this.ddDataConnection_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		public void SetXml (string extProperties) 
		{
			XmlDocument xml = new XmlDocument();

			xml.LoadXml(extProperties);

			tempNode = xml.SelectSingleNode("//ListBox");

			if (tempNode == null) 
			{
				XmlDocument tempXml = new XmlDocument();

				tempXml.LoadXml(extProperties);

				tempNode = tempXml.SelectSingleNode("//ExtendedProperties");

				XmlDocument cbXml = new XmlDocument();

				cbXml.Load(System.Web.HttpContext.Current.Server.MapPath("~\\DesktopModules\\DNNContentBuilder\\UserControls\\FieldControls\\XML\\ListBoxDef.xml"));

				tempNode.InnerXml = cbXml.InnerXml;

				xmlDoc.LoadXml(tempXml.OuterXml);
			} 
			else 
			{
				xmlDoc.LoadXml(extProperties);
			}

			//Fill Option text and option value

			this.FillddDataConnection(xmlDoc.InnerXml);

			tempNode = xmlDoc.SelectSingleNode("//ListSize");

			if (tempNode.InnerText != "") 
			{
				this.ddListSize.SelectedValue = tempNode.InnerText;
			}

			this.txtWhere.Text = tempNode.InnerText;

			tempNode = xmlDoc.SelectSingleNode("//Where");
			this.txtWhere.Text = tempNode.InnerText;
				
			tempNode = xmlDoc.SelectSingleNode("//OrderBy");
			this.txtOrderBy.Text = tempNode.InnerText;

			System.Web.UI.Control lastButton = Page.FindControl((string)Session["lastButton"]);

			((ImageButton)lastButton).CommandArgument = xmlDoc.OuterXml;
		}

		public void FillddDataConnection(string xml) 
		{
			xmlDoc.LoadXml(xml);

			DNNContentBuilder.DataConnectionController dcController = new DataConnectionController();

			this.ddDataConnection.DataSource = (ArrayList)dcController.GetAllDataConnections();
			this.ddDataConnection.DataTextField = "TableName";
			this.ddDataConnection.DataValueField = "DataConnectionId";
			this.ddDataConnection.DataBind();

			tempNode = xmlDoc.SelectSingleNode("//DataConnectionId");
			
			if (tempNode.InnerText == "") 
			{
				if (this.ddDataConnection.Items.Count > 0) 
				{
					ddDataConnection.SelectedIndex = 0;
					dcInfoTemp = (DataConnectionInfo)dcController.GetItem(Int32.Parse(this.ddDataConnection.SelectedValue));
					tempNode.InnerText = this.ddDataConnection.SelectedValue;
				} 
			} 
			else 
			{
				dcInfoTemp = dcController.GetItem(Int32.Parse(tempNode.InnerText));
				this.ddDataConnection.SelectedValue = tempNode.InnerText;
			}

			DNNContentBuilder.ConnectionStringController csController = new ConnectionStringController();
			DNNContentBuilder.DatabaseController dbController = new DatabaseController();

			DNNContentBuilder.ConnectionStringInfo csInfo = (ConnectionStringInfo)csController.GetItem(dcInfoTemp.ConnectionStringId);

			DNNContentBuilder.DatabaseInfo dbInfo = (DatabaseInfo)dbController.GetItem(csInfo.DatabaseId);

			OleDbConnection tableSourceConnection = new OleDbConnection(csInfo.ConnectionString);

			OleDbCommand tableSourceCommand = new OleDbCommand(dbInfo.SysColumnQuery.Replace("@table_name", this.ddDataConnection.SelectedItem.Text), tableSourceConnection);

			try 
			{
				tableSourceConnection.Open();

				OleDbDataReader tableSourceReader = tableSourceCommand.ExecuteReader(CommandBehavior.CloseConnection);
				
				while (tableSourceReader.Read()) 
				{
					fieldList.Add(new DNNContentBuilder.FieldInfo(tableSourceReader.GetString(0).Remove(0,tableSourceReader.GetString(0).IndexOf(".")+1), tableSourceReader.GetString(0), tableSourceReader.GetString(2),0,0, ""));
				}
			}
			catch (Exception error) 
			{
				string x = error.Message; //just for debug
				return;
			}

			this.ddOptionText.DataSource = fieldList;
			this.ddOptionText.DataTextField = "name";
			this.ddOptionText.DataValueField = "columnProperties";
			this.ddOptionText.DataBind();

			this.ddOptionValue.DataSource = fieldList;
			this.ddOptionValue.DataTextField = "name";
			this.ddOptionValue.DataValueField = "columnProperties";
			this.ddOptionValue.DataBind();

			tempNode = xmlDoc.SelectSingleNode("//ListSize");

			if (tempNode.InnerText != "") 
			{
				this.ddListSize.SelectedValue = tempNode.InnerText;
			} 
			else 
			{
				tempNode.InnerText = this.ddListSize.SelectedValue;
			}
	
			tempNode = xmlDoc.SelectSingleNode("//OptionText");

			if (tempNode.InnerText != "") 
			{
				this.ddOptionText.SelectedValue = tempNode.InnerText;
			} 
			else 
			{
				tempNode.InnerText = ddOptionText.SelectedValue;
			}

			tempNode = xmlDoc.SelectSingleNode("//OptionValue");

			if (tempNode.InnerText != "") 
			{
				this.ddOptionValue.SelectedValue = tempNode.InnerText;
	
			}

		}

		public void GetXml (string xml) 
		{
			XmlDocument tempXml = new XmlDocument();

			tempXml.LoadXml(xml);

			tempNode = tempXml.SelectSingleNode("//DataConnectionId");
			tempNode.InnerText = this.ddDataConnection.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//OptionText");
			tempNode.InnerText = this.ddOptionText.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//OptionValue");
			tempNode.InnerText = this.ddOptionValue.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//ListSize");
			tempNode.InnerText = this.ddListSize.SelectedValue;

			tempNode = tempXml.SelectSingleNode("//Where");
			tempNode.InnerText = this.txtWhere.Text;

			tempNode = tempXml.SelectSingleNode("//OrderBy");
			tempNode.InnerText = this.txtOrderBy.Text;

			tempNode = tempXml.SelectSingleNode("//UniqueId");
			
			System.Web.UI.Control lastButton = Page.FindControl(tempNode.InnerText);
			
			((ImageButton)lastButton).CommandArgument = tempXml.OuterXml;
		}

		private void ddDataConnection_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			System.Web.UI.Control lastButton = Page.FindControl((string)Session["lastButton"]);

			xmlDoc.LoadXml(((ImageButton)lastButton).CommandArgument);

			tempNode = xmlDoc.SelectSingleNode("//DataConnectionId");
			tempNode.InnerText = ddDataConnection.SelectedValue;

			tempNode = xmlDoc.SelectSingleNode("//OptionText");
			tempNode.InnerText = "";

			tempNode = xmlDoc.SelectSingleNode("//OptionValue");
			tempNode.InnerText = "";
			
			this.FillddDataConnection(xmlDoc.InnerXml);
		}
	}//class
}//namespace
