/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)
 
 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/
using DNNContentBuilder.UserControls.FieldControls;

namespace DNNContentBuilder.UserControls.SearchFieldControls
{
	using System;
	using System.Xml;
	

	/// <summary>
	///		Summary description for TextSearchControl.
	/// </summary>
	public class NumberSearchControl : System.Web.UI.UserControl, ISearchControl
	{
		protected NumberBoxControl txtFrom;
		protected NumberBoxControl txtTo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region ISearchControl Members

		public Type DataType
		{
			get
			{
				return typeof(System.Double);
			}
		}

		public string SearchCriteria
		{
			get
			{
				string xml = ContextUtil.GetTypeXml();
				
				XmlDocument xmlDoc = new XmlDocument();
				
				xmlDoc.LoadXml(txtFrom.GetValue(xml));
				
				string valueFrom = ContextUtil.GetAttributeValue(xmlDoc, "Value", "");
				
				xmlDoc.LoadXml(txtTo.GetValue(xml));

				string valueTo = ContextUtil.GetAttributeValue(xmlDoc, "Value", "");

				if (valueFrom != "" || valueTo != "")
				{
						valueFrom = Double.Parse(valueFrom, System.Globalization.NumberStyles.Number).ToString();
						valueTo   = Double.Parse(valueTo, System.Globalization.NumberStyles.Number).ToString();

						if (valueFrom == "") {
							valueFrom = Double.MinValue.ToString();
						}
						
						if (valueTo == "") {
							valueTo = Double.MaxValue.ToString();
						}
						
						return String.Format(" BETWEEN {0} AND {1}", valueFrom, valueTo);
				}

				return null;
			}
		}

		public void SetConfig(string xml)
		{
			txtFrom.SetConfig(xml);
			txtTo.SetConfig(xml);
		}

		#endregion
	}
}
