/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

namespace DNNContentBuilder.UserControls
{
	public delegate void TaskClickEventHandler(object sender, TaskClickEventArgs e);

	/// <summary>
	/// Provides event arguments for the TaskClickEventHandler 
	/// delegate.
	/// </summary>
	public class TaskClickEventArgs : System.EventArgs
	{
		#region Class Members
		private int metaDataId;
		private int taskId;
		#endregion

		#region Constructors
		/// <summary>
		/// Initializes a new instance of the TaskClickEventArgs class.
		/// </summary>
		/// <param name="metaDataId"></param>
		public TaskClickEventArgs(int metaDataId, int taskId)
		{
			this.metaDataId = metaDataId;
			this.taskId = taskId;
		}
		#endregion

		#region Properties
		/// <summary>
		/// Gets the metadata ID for the row clicked
		/// </summary>
		public int MetaDataId
		{
			get
			{
				return metaDataId;
			}
		}
		public int TaskId
		{
			get
			{
				return taskId;
			}
		}
		#endregion
	}
}
