/*
 DNN Content Builder- sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

namespace DNNContentBuilder.UserControls
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using DotNetNuke;
	using System.Collections;

	/// <summary>
	///		Summary description for UsersRolesControl.
	/// </summary>
	public class UsersRolesControl : System.Web.UI.UserControl
	{

		private DotNetNuke.Entities.Users.UserController userController = new DotNetNuke.Entities.Users.UserController();
		private DotNetNuke.Security.Roles.RoleController roleController = new DotNetNuke.Security.Roles.RoleController();
		private ArrayList users = new ArrayList();
		protected System.Web.UI.HtmlControls.HtmlSelect lbUsersAvailable;
		protected System.Web.UI.HtmlControls.HtmlSelect lbUsersSelected;
		protected System.Web.UI.HtmlControls.HtmlSelect lbRolesAvailable;
		protected System.Web.UI.HtmlControls.HtmlSelect lbRolesSelected;
		protected System.Web.UI.WebControls.Literal ltScript;
		private ArrayList roles = new ArrayList();

		private void Page_Load(object sender, System.EventArgs e)
		{
				int portalID = int.Parse(Request.Params["URPortalID"]);
			              
				users = DotNetNuke.Entities.Users.UserController.GetUsers(portalID);
				
				roles = roleController.GetRoles();

				this.lbUsersAvailable.DataSource = users;
				this.lbUsersAvailable.DataTextField = "Username";
				this.lbUsersAvailable.DataValueField = "UserID";
				this.lbUsersAvailable.DataBind();

				this.lbRolesAvailable.DataSource = roles;
				this.lbRolesAvailable.DataTextField = "RoleName";
				this.lbRolesAvailable.DataValueField = "RoleID";
				this.lbRolesAvailable.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		public void SetValues(ArrayList users, ArrayList roles) 
		{
			this.lbUsersAvailable.DataSource = users;
			this.lbUsersAvailable.DataTextField = "Username";
			this.lbUsersAvailable.DataValueField = "UserId";
			this.lbUsersAvailable.DataBind();

			this.lbRolesAvailable.DataSource = roles;
			this.lbRolesAvailable.DataTextField = "RoleName";
			this.lbRolesAvailable.DataValueField = "RoleID";
			this.lbRolesAvailable.DataBind();

			Session.Add("user",users);
			Session.Add("roles",roles);
		}
	}
}
