/*
 DNN Content Builder - sourceforge.net/projects/dnncb
 Copyright (c) 2004-2008
 by Emerson Lopes (emersonlopes@gmail.com)

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
 documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
 the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
 to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions 
 of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
 TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 DEALINGS IN THE SOFTWARE.
*/

using System;
using System.Collections;
using System.Data;

namespace DNNContentBuilder 
{
	[Serializable]
	public class WorkflowInfo 
	{
        
		// Entity member variables for database table epWorkflow
        
		private Int32 mWorkflowId;
		private string mTitle;
		private string mDescription;
        
		// Calculated Expression member variables for database table epWorkflow
        
        
		// Entity properties for database table epWorkflow
        
		public Int32 WorkflowId 
		{
			get { return mWorkflowId; }
			set { mWorkflowId = value; }
		}
        
        
		public string Title 
		{
			get { return mTitle; }
			set { mTitle = value; }
		}
        
        
		public string Description 
		{
			get { return mDescription; }
			set { mDescription = value; }
		}
        
        
	}
    
	public class WorkflowController : BaseController
	{
		public WorkflowController() : base() {}

		public WorkflowController(ConnectionProvider cp) : base(cp) {}
        
		public Int32 Add(WorkflowInfo WorkflowInfo) 
		{
			return (Int32) base.GetDataProvider().WorkflowAdd(WorkflowInfo.Title, WorkflowInfo.Description);
		}
        
		public void Update(WorkflowInfo WorkflowInfo) 
		{
			base.GetDataProvider().WorkflowUpdate(WorkflowInfo.WorkflowId, WorkflowInfo.Title, WorkflowInfo.Description);
		}
        
		public void Delete(Int32 workflowId) 
		{
			base.GetDataProvider().WorkflowDelete(workflowId);
		}
        
		public WorkflowInfo GetItem(Int32 workflowId) 
		{
			using (IDataReader idr = base.GetDataProvider().WorkflowGet(workflowId))
			{
				WorkflowInfo infoObject = (WorkflowInfo)DotNetNuke.Common.Utilities.CBO.FillObject(idr, typeof(WorkflowInfo));
				return infoObject;
			} 
		}
        
		// Select query methods for database table Workflow
        
		public ArrayList GetAllWorkflows() 
		{
			using (IDataReader idr = base.GetDataProvider().WorkflowGetAllWorkflows())
			{
				ArrayList infoList = DotNetNuke.Common.Utilities.CBO.FillCollection(idr, typeof(WorkflowInfo));
				return infoList;
			} 
		}
	}
}
